/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using UnityEngine.UI;using System.Linq;namespace PluginIdea{    public class FreeControllerModule : GZModuleBase    {        class AtomColorInfo        {            public Atom atom;            public Color color = Color.white;        }        private List<Color> colors = new List<Color> {                        new Color(0,1,0),            new Color(0,0,1),            new Color(1,0,1),            new Color(1,1,1),            new Color(0,1,1),            new Color(1,1,0),            new Color(0.5f,0.5f,0),             new Color(0,0.7f,0.5f),             new Color(0,0.75f,0),        };        private Dictionary<string, AtomColorInfo> dic_uid2Atom = new Dictionary<string, AtomColorInfo>();        private JSONStorableBool isUseCustomIcon;        private JSONStorableBool isUseRandomColor;        private JSONStorableStringChooser personAtomsChooser;        private JSONStorableColor personControllerColor;        private JSONStorableBool isDrawMeshWhenSelected;        private Color defaultOnColor = Color.green;        private Mesh defaultDeselectMesh;        private List<string> personStrs = new List<string>();        private int index = 0;        private List<object> customColorUIList = new List<object>();        private FreeControllerV3 sceneLastSelectedController;        public FreeControllerModule(GizmosSystem ower)        {            this.ower = ower;            SuperController.singleton.onAtomAddedHandlers += OnAtomAdded;            SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;        }        public override void Init()        {            UIInit();            RefreshAtomControllerIcon();            RefreshAtomControllerColor();        }        private void UIInit()        {            Utils.SetupInfoTextNoScroll(this.ower, "<size=30><b>Controller's Color&Icon</b></size>", 35, true);            Utils.SetupButton(ower, "Refresh List", () =>            {                RefreshPersonCustomColorUI();            }, true);            personAtomsChooser = Utils.SetupStringChooser(ower, "Persons", personStrs, 0, true);            isDrawMeshWhenSelected = Utils.SetupToggle(ower, "Is Draw Icon When Selected", true, true);                                                            isUseRandomColor = Utils.SetupToggle(ower, "Is Use Custom Controller Color", true, true);            isUseRandomColor.setCallbackFunction = (val) => {                RefreshAtomControllerColor();            };            personControllerColor = Utils.SetupColor(ower, "Color Select", Color.white, true);            personControllerColor.setCallbackFunction = (h, s, v) => {                if (dic_uid2Atom.Count > 0)                {                    Atom atom = dic_uid2Atom[personAtomsChooser.val].atom;                    Color color = Color.HSVToRGB(h, s, v);                    dic_uid2Atom[personAtomsChooser.val].color = color;                    SetAtomControllerV3Color(atom, color);                }            };        }        private void RefreshPersonCustomColorUI()        {            dic_uid2Atom.Clear();            personStrs = SuperController.singleton.GetAtoms().Where(x => x.type == "Person").Select(x => x.uid).ToList();            personStrs.ForEach(uid =>            {                dic_uid2Atom.Add(uid, new AtomColorInfo()                {                    atom = SuperController.singleton.GetAtomByUid(uid),                });            });            if (dic_uid2Atom.Count > 0)            {                personAtomsChooser.choices = personStrs;                personAtomsChooser.val = personStrs[0];            }        }        private void RefreshAtomControllerIcon()        {            SuperController.singleton.GetAtoms().ForEach(atom =>            {                SetAtomControllerIcon(atom, true);            });        }        private void RefreshAtomControllerColor()        {            SuperController.singleton.GetAtoms().ForEach(atom =>            {                if (isUseRandomColor.val)                {                    if (atom.type != "Person" || !dic_uid2Atom.ContainsKey(atom.uid))                    {                        index++;                        if (index == colors.Count) index = 0;                        Color rc = colors[index];                        SetAtomControllerV3Color(atom, rc);                    }                    else                    {                        if (dic_uid2Atom.ContainsKey(atom.uid))                        {                            SetAtomControllerV3Color(atom, dic_uid2Atom[atom.uid].color);                        }                    }                }                else                {                    SetAtomControllerV3Color(atom, defaultOnColor);                }            });        }        private void SetAtomControllerV3Color(Atom atom, Color color)        {            atom.freeControllers.ToList().ForEach(v3 =>            {                v3.onColor = color;                v3.highlighted = false;            });        }        private void SetAtomControllerIcon(Atom atom, bool customIcon)        {            int index = 0;            atom.freeControllers.ToList().ForEach(v3 =>            {                if (atom.type == "Person")                {                    if (customIcon)                    {                        index++;                        switch (v3.name)                        {                            case "chestControl":                                v3.deselectedMesh = ower.Dic_Meshes["chest"];                                break;                            case "headControl":                                v3.deselectedMesh = ower.Dic_Meshes["head"];                                break;                            case "rHandControl":                                v3.deselectedMesh = ower.Dic_Meshes["handR"];                                break;                            case "lHandControl":                                v3.deselectedMesh = ower.Dic_Meshes["handL"];                                break;                            case "rFootControl":                                v3.deselectedMesh = ower.Dic_Meshes["footR"];                                break;                            case "lFootControl":                                v3.deselectedMesh = ower.Dic_Meshes["footL"];                                break;                            case "rElbowControl":                            case "lElbowControl":                                v3.deselectedMesh = ower.Dic_Meshes["enbow"];                                break;                            case "rKneeControl":                            case "lKneeControl":                                v3.deselectedMesh = ower.Dic_Meshes["knee"];                                break;                            case "rArmControl":                            case "lArmControl":                                v3.deselectedMesh = ower.Dic_Meshes["arm"];                                break;                            case "penisBaseControl":                            case "penisMidControl":                            case "penisTipControl":                                v3.deselectedMesh = ower.Dic_Meshes["pelvis"];                                break;                        }                    }                }            });        }        public override void OnUpdate()        {            base.OnUpdate();            FreeControllerV3 f3 = SuperController.singleton.GetSelectedController();            if (f3 != null && f3 != sceneLastSelectedController)            {                sceneLastSelectedController = f3;                if (isDrawMeshWhenSelected.val)                {                    f3.meshScale = f3.containingAtom.type == "Person" ? 0.5f : 0.2f;                }                else                {                    f3.meshScale = 0.0001f;                }            }        }        private void OnAtomAdded(Atom atom)        {            if (!SuperController.singleton.isLoading)            {                RefreshAtomControllerIcon();                RefreshAtomControllerColor();            }        }        private void OnSceneLoaded()        {            RefreshPersonCustomColorUI();            RefreshAtomControllerIcon();            RefreshAtomControllerColor();        }                    public override void UnInit()        {            SuperController.singleton.onAtomAddedHandlers -= OnAtomAdded;            SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;            isUseRandomColor.val = false;            isUseRandomColor.val = false;        }    }}